<template>
    <Page>
        <ScrollView>
            <GridLayout rows="auto,*,*">
                <StackLayout class="margin">
                    <Label 
                        text="Imagen tomada" 
                        :style="{'text-align': 'center'}" 
                        textWrap="true">
                    </Label>
                    <StackLayout>    
                        <Image 
                        :src="photo.picture_base_64" 
                        height="40%" 
                        width="100%"/>
                    </StackLayout>
                    <Label 
                        text="Descripcion" 
                        :style="{'text-align': 'center'}" 
                        textWrap="true"
                        marginTop="10">
                    </Label>
                    <TextView 
                        v-model="descripcion" 
                        textWrap="true"
                        borderBottomWidth="3" 
                        borderBottomColor="#cec8c8"/>
                    <Label 
                        text="Seleccione la actividad" 
                        :style="{'text-align': 'center'}" 
                        textWrap="true"
                        marginTop="10">
                    </Label>
                    <ListPicker :items="actividades.map((e) => { return e.descripcion; })" v-model="actividad" />
                    <!-- <Label 
                        :text="'Seleccione el tipo de actividad'" 
                        :style="{'text-align': 'center'}" 
                        textWrap="true"
                        marginTop="10">
                    </Label>
                    <ListPicker :items="tipos.map((e) => { return e.clave; })" v-model="tipo" /> -->
                    <StackLayout horizontalAlignment="center" v-show="!processing" orientation="horizontal">
                        <Button @tap="$navigateBack" text="Cancelar"/>
                        <Button @tap="guardarDatos()" text="Guardar"/>                    
                    </StackLayout>
                </StackLayout>
                <ActivityIndicator :busy="processing" color="#7d00cc" row="0" rowSpan="3"></ActivityIndicator>
            </GridLayout>
        </ScrollView>
    </Page>
</template>

<script>
import store from "../../store";
import { mapGetters } from 'vuex';
import axios from 'axios';
import { urlApi, EventBus } from '../../main.js';
import IncidencesPageVue from '../../pages/IncidencesPage.vue';

export default {
    props: ['photo'],
    data(){
        return{
            processing: false,
            tipos: [],
            actividades: [],
            tipo: 0,
            actividad: 0,
            descripcion: null
        }
    },
    created(){
        // this.obtenerTiposActividad();
        this.obtenerActividades();
    },
    methods:{
        obtenerActividades(){
            axios.get(urlApi+'/api/v1/mtto/mantenimientos/listado')
            .then(data => {
                this.actividades = data.data;
            })
            .catch(err => {
                console.log("Error -> " + err.message);
            });
        },
        // obtenerTiposActividad(){
        //     axios.get(urlApi+'/api/v1/mtto/tiposMantenimiento/listado')
        //     .then(data => {
        //         this.tipos = data.data;
        //     })
        //     .catch(err => {
        //         console.log("Error -> " + err.message);
        //     });
        // },
        guardarDatos(){
            this.processing = true;

            for (let i = 0; i < this.actividades.length; i++) {
                if (this.actividad == i) {
                    this.actividad = this.actividades[i].id;
                    break;
                }
            }

            // for (let i = 0; i < this.tipos.length; i++) {
            //     if (this.tipo == i) {
            //         this.tipo = this.tipos[i].id;
            //         break;
            //     }
            // }
            let nombre = 'incidencia_'+(Math.floor((Math.random() * 5000) + 100))+'.png';
            
            axios.post(urlApi+`/api/v1/mtto/incidences/${this.actividad}/add-incidence`, {
                nombre: nombre,
                foto: this.photo.picture_base_64,
                descripcion: this.descripcion
            })
            .then(data=>{
                this.processing = false;
                console.log('registrado correctamente');
                EventBus.$emit('saved', data.data);
                this.$navigateTo(IncidencesPageVue);
            })
            .catch(err => {
                console.log("Error -> " + err.message);
            });
        }
    }
}
</script>

<style scoped>
    .margin{
        margin-left: 20;
        margin-right: 20;
        margin-bottom: 20;
        margin-top: 20;
    }
</style>

